debug = true
--TODO FALSE
Player = { x = 240, y = 355, speed = 250, sprite = nil, HP = 5}
isAlive =  true
score = 0
--
------
------
--
canShoot = true
canShootTimerMax = 0.2
canShootTimer = canShootTimerMax
--
bulletSprite = nil
bullets = {}
--
createEnemyTimerMax = 2
createEnemyTimer = createEnemyTimerMax
enemies = {}
enemySprite = nil

enemyBulletSprite = nil
enemyBullets = {}

canShootEnemy = true
canShootEnemyTimerMax = 0.8
canShootEnemyTimer = canShootEnemyTimerMax
--
function love.load(arg)
Player.sprite = love.graphics.newImage('Assets/Sprites/Plane.png')
enemyBulletSprite = love.graphics.newImage('Assets/Sprites/EnemyBullet.png')
bulletSprite = love.graphics.newImage('Assets/Sprites/Bullet.png')
enemySprite = love.graphics.newImage('Assets/Sprites/Enemy.png')
end

--

function love.draw(dt)
--
if isAlive then
	for i, enemyBullet in ipairs(enemyBullets) do
		love.graphics.draw(enemyBullet.sprite, enemyBullet.x, enemyBullet.y)
	end
	--
	--
	love.graphics.draw(Player.sprite, Player.x, Player.y)
	--
	for i, bullet in ipairs(bullets) do
		love.graphics.draw(bullet.sprite, bullet.x, bullet.y)
	end
	--
	for i, enemy in ipairs(enemies) do
		love.graphics.draw(enemy.sprite, enemy.x, enemy.y)
	end
	love.graphics.print("Score: " .. score, love.graphics:getWidth()-80, 15)
	love.graphics.print("Lives: " .. Player.HP, 10, 15)
else
	love.graphics.print("Press 'R' to restart", love.graphics:getWidth()/2-50, love.graphics:getHeight()/2-10)
	love.graphics.print("Your score is: " .. score, love.graphics:getWidth()/2-50, love.graphics:getHeight()/2-30)
end
--
end

--

function love.update(dt)
--Enemies
	createEnemyTimer = createEnemyTimer - (1*dt)
	if createEnemyTimer < 0 then
		createEnemyTimer = createEnemyTimerMax
		rand = math.random(10, love.graphics.getWidth() - 10 - enemySprite:getWidth())
		newEnemy = { x = rand, y = -10 - enemySprite:getHeight(), sprite = enemySprite }
    newEnemy.canShoot = true
    newEnemy.timer = 0
		table.insert(enemies, newEnemy)
	end

if Player.HP == 0 then
	isAlive = false
end
if isAlive == true then

--Check Shooting
	for i, enemy in ipairs(enemies) do
    
    -- Update Shooting interval timer --
    enemy.timer = enemy.timer - (1*dt)
    if enemy.timer < 0 then
      enemy.canShoot = true
    end
    
    -- Spawn Bullet --
		if enemy.canShoot then
			newEnemyBullet = { x = enemy.x + enemy.sprite:getWidth()/2 - enemyBulletSprite:getWidth()/2, y = enemy.y + enemy.sprite:getHeight() - enemyBulletSprite:getHeight(), sprite = enemyBulletSprite}
			table.insert(enemyBullets, newEnemyBullet)
			enemy.canShoot = false
      enemy.timer = canShootEnemyTimerMax
		end
    
    -- Check for Collisions --
		for j, bullet in ipairs(bullets) do
			if enemy.HP == nil then
				enemy.HP = 2
			end
			if CheckCollision(enemy.x, enemy.y, enemy.sprite:getWidth(), enemy.sprite:getHeight(), bullet.x, bullet.y, bullet.sprite:getWidth(), bullet.sprite:getHeight()) then
				enemy.HP = enemy.HP - 1
				table.remove(bullets, j)
				if enemy.HP == 0 then
					table.remove(enemies, i)
					score = score + 10
					enemy.HP = 2
				end
			end
		end
    
--Shooting enemies
		for k, enemyBullet in ipairs(enemyBullets) do
			if CheckCollision(enemyBullet.x, enemyBullet.y, enemyBullet.sprite:getWidth(), enemyBullet.sprite:getHeight(), Player.x, Player.y, Player.sprite:getWidth(), Player.sprite:getHeight())
				and isAlive then
					Player.HP = Player.HP - 1
					table.remove(enemyBullets, k)
			end
		end
		if CheckCollision(enemy.x, enemy.y, enemy.sprite:getWidth(), enemy.sprite:getHeight(), Player.x, Player.y, Player.sprite:getWidth(), Player.sprite:getHeight())
			and isAlive then
				Player.HP = Player.HP - 1
				table.remove(enemies, i)
		end
	end
--Shooting
	canShootTimer = canShootTimer - (1*dt)
	if canShootTimer < 0 then
		canShoot = true
	end
	if love.keyboard.isDown(' ') and canShoot then
		newBullet = { x = Player.x + (Player.sprite:getWidth()/2) - (bulletSprite:getWidth()/2), y = Player.y, sprite = bulletSprite}
		table.insert(bullets, newBullet)
		canShoot = false
		canShootTimer = canShootTimerMax
	end
--Bullets move
	for i, bullet in ipairs(bullets) do
		bullet.y = bullet.y - (250 * dt)
		if bullet.y < 0 then 
			table.remove(bullets, i)
		end
	end
--Enemy bullets move
	for i, enemyBullet in ipairs(enemyBullets) do
		enemyBullet.y = enemyBullet.y + (250 * dt)
		if enemyBullet.y > 710 then
			table.remove(enemyBullets, i)
		end
	end
--Enemies move
	for i, enemy in ipairs(enemies) do
		enemy.y = enemy.y + (50*dt)

		if enemy.y > 710 - enemySprite:getHeight() then
			table.remove(enemies, i)
			if score > 0 then
				score = score - 50
				if score < 0 then
					score = 0
					Player.HP = Player.HP - 1
				end
			else
				Player.HP = Player.HP - 1
			end
		end
	end
--Moving
	if love.keyboard.isDown('a') then
		if Player.x > 0 then
			Player.x = Player.x - (Player.speed*dt)
		end
	elseif love.keyboard.isDown('d') then
		if Player.x < (love.graphics.getWidth() - Player.sprite:getWidth()) then
			Player.x = Player.x + (Player.speed*dt)
		end
	end

	if love.keyboard.isDown('w') then
		if Player.y > 0 then
			Player.y = Player.y - (Player.speed*dt)
		end
	end

	if love.keyboard.isDown('s') then
		if Player.y < (love.graphics.getHeight() - Player.sprite:getHeight()) then
			Player.y = Player.y + (Player.speed*dt)
		end
	end
--When u dead
else
	if love.keyboard.isDown('r') then
		bullets = {}
		enemyBullets = {}
		enemies = {}
		canShootTimer = canShootTimerMax
		createEnemyTimer = createEnemyTimerMax
		score = 0
		isAlive = true
		Player.HP = 5
		Player.x = 240
		Player.y = 355
	end
end
-- Escape
	if love.keyboard.isDown('escape') then
		love.event.push('quit')
	end
end

function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
	return x1 < x2+w2 and
		   x2 < x1+w1 and
		   y1 < y2+h2 and
		   y2 < y1+h1
end